
use imgui_glow_renderer::AutoRenderer;
use imgui_sdl2_support::SdlPlatform;

use sdl2::event::Event;
const MODELS: [&str; 3]= ["resources/models/TestCarModel/CarW4.obj", "resources/models/TestCarModel/CarW1.obj",
"resources/models/TestCarModel/CarW0.obj"];


pub struct Debug {
    imgui: imgui::Context,
    renderer: AutoRenderer,
    platform: SdlPlatform,
}

impl Debug {
    pub fn new(gl: std::sync::Arc<glow::Context>) -> Debug
        {
            let mut imgui = imgui::Context::create();

            imgui
                .fonts()
                .add_font(&[imgui::FontSource::DefaultFontData {config: None}]);

            let mut platform = SdlPlatform::init(&mut imgui);
            let mut renderer = match AutoRenderer::initialize(gl.clone(), &mut imgui)
                {
                    Ok(ret) => ret,
                    Err(s) => panic!("Failed to initialize Imgui Platform Renderer: {}", s),
                };
            Debug {
                imgui,
                renderer,
                platform
            }
        }

    pub fn handle(&mut self, event: &sdl2::event::Event)
        {
            self.platform.handle_event(&mut self.imgui, event);
        }

    pub fn drawImgui(&mut self, events_loop: &sdl2::EventPump, window: &sdl2::video::Window,
    tempData: &mut crate::scene::tempData, Car: &crate::model::Model)
        {
            self.platform.prepare_frame(&mut self.imgui, &window, &events_loop );
            let ui = self.imgui.new_frame();
            let mut hello = String::new();

            ui.window("POLY I WILL FUCKING")
                  .size([500.0, 100.0], imgui::Condition::FirstUseEver)
                  .build(|| {
                      ui.text("you serve no purpose in life");
                      ui.text("Your Purpose in life is to suck my dick");
                      ui.slider("The Spin Speed", 0.1, 10.0, &mut tempData.spinSpeed);
                      if ui
                          .button("Quit") {
                              hello = String::from("cannot quit from here");

                          }
                      ui.text(hello);
                  });

            ui.window("Stats")
              .size([300.0,500.0], imgui::Condition::Always)
              .build(|| {
                  ui.text("Model Information");
                  ui.separator();
                  ui.text(format!("count meshes: {}", Car.meshes.len()));
                  for i in 0..Car.meshes.len()
                  {
                      ui.text(format!("Mesh Number: {}",i ));
                      ui.text(format!("count vertices: {}", Car.meshes[i].vertices.len()));
                      ui.separator();
                  }
              });


            let draw_data = self.imgui.render();

            self.renderer.render(draw_data).unwrap();

        }

}
